// HTTPRemoteFileDlg.cpp : implementation file
//

#define STRICT

#include "stdafx.h"
#include "HTTPTest.h"
#include "HTTPDlg.h"
#include "HThrd.h"
#include "HThrdMgr.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

///////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
    CAboutDlg();

// Dialog Data
    //{{AFX_DATA(CAboutDlg)
    enum { IDD = IDD_ABOUTBOX };
    //}}AFX_DATA

    // ClassWizard generated virtual function overrides
    //{{AFX_VIRTUAL(CAboutDlg)
    protected:
    virtual void DoDataExchange(CDataExchange* pDX);    
        // DDX/DDV support
    //}}AFX_VIRTUAL

// Implementation
protected:
    //{{AFX_MSG(CAboutDlg)
    //}}AFX_MSG
    DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
    //{{AFX_DATA_INIT(CAboutDlg)
    //}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CAboutDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
    //{{AFX_MSG_MAP(CAboutDlg)
        // No message handlers
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////
// CHTTPRemoteFileDlg dialog

CHTTPRemoteFileDlg::CHTTPRemoteFileDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHTTPRemoteFileDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CHTTPRemoteFileDlg)
        // NOTE: the ClassWizard will add member 
        // NOTE: initialization here
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a 
    // subsequent DestroyIcon in Win32
    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    m_pThreadMgr = NULL ;
}

CHTTPRemoteFileDlg::~CHTTPRemoteFileDlg()
{
    // Delete the CHTTPThreadMgr instance
    if (m_pThreadMgr)
        delete m_pThreadMgr ;
}

void CHTTPRemoteFileDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CHTTPRemoteFileDlg)
        // NOTE: the ClassWizard will add DDX and DDV calls here
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHTTPRemoteFileDlg, CDialog)
    //{{AFX_MSG_MAP(CHTTPRemoteFileDlg)
    ON_WM_SYSCOMMAND()
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_MESSAGE(WM_THREADCOMPLETE, OnThreadComplete)
    ON_BN_CLICKED(IDC_GET, OnGetFile)
    ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BROWSE, OnBrowse)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

///////////////////////////////////////////////////////////////////
// CHTTPRemoteFileDlg message handlers

BOOL CHTTPRemoteFileDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    // Add "About..." menu item to system menu.

    // IDM_ABOUTBOX must be in the system command range.
    ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
    ASSERT(IDM_ABOUTBOX < 0xF000);

    CMenu* pSysMenu = GetSystemMenu(FALSE);
    CString strAboutMenu;
    strAboutMenu.LoadString(IDS_ABOUTBOX);
    if (!strAboutMenu.IsEmpty())
    {
        pSysMenu->AppendMenu(MF_SEPARATOR);
        pSysMenu->AppendMenu(MF_STRING, 
            IDM_ABOUTBOX, strAboutMenu);
    }

    SetIcon(m_hIcon, TRUE);			// Set big icon
    SetIcon(m_hIcon, FALSE);		// Set small icon

    // Create a new instance of the CHTTPThreadMgr()
    m_pThreadMgr = new CHTTPThreadMgr() ;
    if (m_pThreadMgr)
        m_pThreadMgr->InitThreads(this, (char *) APPNAME) ;
	
    // Set a callback timer to update statistics
    SetTimer(5, 500, NULL) ;

    return (TRUE) ;
}

void CHTTPRemoteFileDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
    if ((nID & 0xFFF0) == IDM_ABOUTBOX)
    {
        CAboutDlg dlgAbout;
        dlgAbout.DoModal();
    }
    else
    {
        CDialog::OnSysCommand(nID, lParam);
    }
}

void CHTTPRemoteFileDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, 
            (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CDialog::OnPaint();
    }
}

HCURSOR CHTTPRemoteFileDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}

LRESULT CHTTPRemoteFileDlg::OnThreadComplete(WPARAM wParam, 
                                             LPARAM lParam)
{
    // Notification message from the CHTTPThreadMgr that
    // a thread has completed.
    // wParam = HIWORD : return code of thread
    // wParam = LOWORD : thread number
    // lParam = filename of local file from the 
    //          thread which completed

    char    szFilename[255] ;
    char    buffer[255] ;

    strcpy(szFilename, (char *) lParam) ;

    strcpy(buffer, "thread complete - ") ;
    
    // check the return code
    switch(HIWORD(wParam))
    {
        case HTTPTHREAD_SUCCESS:
            strcat(buffer, "SUCCESS") ;
            break ;

        case HTTPTHREAD_COULDNOTSAVEFILE:
            strcat(buffer, "Could not save local file") ;
            break ;
    
        case HTTPTHREAD_COULDNOTCONNECT:
            strcat(buffer, "Could not connect to remote server") ;
            break ;
        
        case HTTPTHREAD_FILENOTFOUND:
            strcat(buffer, "Remote file not found") ;
            break ;

        case HTTPTHREAD_FAILURE:
        default:
            strcat(buffer, "FAILED") ;
            break ;
    }

    MessageBox(szFilename, buffer, MB_ICONINFORMATION | MB_OK) ;

    UpdateStatistics() ;

    return (0L) ;
}

void CHTTPRemoteFileDlg::OnGetFile() 
{
    char    szURL[255] ;
    char    szFilename[255] ;

    if (!GetDlgItemText(IDC_REMOTEFILE, szURL, sizeof(szURL)))
    {
        MessageBox("Please provide the URL for a remote file.", 
            APPNAME, MB_ICONINFORMATION) ;
        GetDlgItem(IDC_REMOTEFILE)->SetFocus() ;
        return ;
    }

    if (!GetDlgItemText(IDC_LOCALFILE, szFilename, 
        sizeof(szFilename)))
    {
        MessageBox("Please provide a local filename "
                   "where the remote file will be saved.", 
                   APPNAME, MB_ICONINFORMATION) ;
        GetDlgItem(IDC_LOCALFILE)->SetFocus() ;
        return ;
    }

    // Tell the CHTTPThreadMgr to get the remote file...
    if (m_pThreadMgr)
        m_pThreadMgr->GetRemoteFile(szURL, szFilename) ;

    UpdateStatistics() ;
}

void CHTTPRemoteFileDlg::UpdateStatistics()
{
    int     iNumQueued = 0 ;
    int     iNumThreads = 0 ;

    if (m_pThreadMgr)
    {
        // Get the number of queued download requests
        // and the number of working threads...
        iNumQueued = m_pThreadMgr->GetPendingRequestCount() ;
        iNumThreads = m_pThreadMgr->GetWorkingThreadCount() ;
    }

    SetDlgItemInt(IDC_NUMQUEUED, iNumQueued) ;
    SetDlgItemInt(IDC_NUMTHREADS, iNumThreads) ;
}

void CHTTPRemoteFileDlg::OnTimer(UINT nIDEvent) 
{
    // Check if any queued download requests can be processed
    if (m_pThreadMgr)
        m_pThreadMgr->CheckNextRequest() ;

    // Update statistics on the dialog
    UpdateStatistics() ;
}

void CHTTPRemoteFileDlg::OnBrowse() 
{
    static char BASED_CODE szFilter[] = "All Files (*.*)|*.*||" ;

    CFileDialog theDlg(FALSE, NULL, NULL, 
        OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, this) ;

    if (theDlg.DoModal() == IDOK)
    {
        SetDlgItemText(IDC_LOCALFILE, 
                       (char *) LPCTSTR(theDlg.GetPathName())) ;
    }
}
