//------------------------------------------------------------------
//  WinNtDdk.h
//------------------------------------------------------------------
#ifndef __WINNTDDK_H
#define __WINNTDDK_H

//------------------------------------------------------------------
// From ntstatus.h
//------------------------------------------------------------------

#define STATUS_WORKING_SET_QUOTA         ((NTSTATUS)0xC00000A1L)
#define STATUS_NOT_ALL_ASSIGNED          ((NTSTATUS)0x00000106L)

//------------------------------------------------------------------
// From ntdef.h
//------------------------------------------------------------------

typedef LONG NTSTATUS;

typedef struct _UNICODE_STRING {
    USHORT Length;
    USHORT MaximumLength;
    PWSTR  Buffer;
} UNICODE_STRING;

#define OBJ_CASE_INSENSITIVE            0x00000040L

typedef struct _OBJECT_ATTRIBUTES {
    ULONG           Length;
    HANDLE          RootDirectory;
    UNICODE_STRING *pObjectName;
    ULONG           Attributes;
    PVOID           SecurityDescriptor;        
    PVOID           SecurityQualityOfService;
} OBJECT_ATTRIBUTES;

//------------------------------------------------------------------
// From ntddk.h
//------------------------------------------------------------------

#if (_MSC_VER >= 800) || defined(_STDCALL_SUPPORTED)
#define NTAPI __stdcall
#else
#define _cdecl
#define NTAPI
#endif

#if !defined(_NTSYSTEM_)
#define NTSYSAPI DECLSPEC_IMPORT
#else
#define NTSYSAPI
#endif

#define SYNCHRONIZE                     (0x00100000L)

#define FILE_SHARE_READ                 0x00000001
#define FILE_SHARE_WRITE                0x00000002
#define FILE_SYNCHRONOUS_IO_ALERT       0x00000010
#define FILE_ANY_ACCESS                 0

typedef struct _IO_STATUS_BLOCK {
    NTSTATUS    Status;
    ULONG       Information;
} IO_STATUS_BLOCK, *PIO_STATUS_BLOCK;

#define SE_INCREASE_QUOTA_PRIVILEGE     5L
#define SE_SYSTEM_PROFILE_PRIVILEGE     11L

typedef enum _PROCESSINFOCLASS {        // Not complete
    ProcessBasicInformation,
    ProcessQuotaLimits
} PROCESSINFOCLASS;

NTSYSAPI NTSTATUS NTAPI NtQueryInformationProcess(
            IN HANDLE ProcessHandle,
            IN PROCESSINFOCLASS ProcessInformationClass,
            OUT PVOID ProcessInformation,
            IN ULONG ProcessInformationLength,
            OUT PULONG ReturnLength OPTIONAL);

NTSYSAPI NTSTATUS NTAPI NtSetInformationProcess(
            IN HANDLE ProcessHandle,
            IN PROCESSINFOCLASS ProcessInformationClass,
            OUT PVOID ProcessInformation,
            IN ULONG ProcessInformationLength);

NTSYSAPI VOID     NTAPI RtlInitUnicodeString(
            UNICODE_STRING *pDestinationString,
            PCWSTR          SourceString);

#endif      

